//
//  FirmwareStorage.h
//  Bluzone
//
//  Created by Jason Clary on 7/28/16.
//  Copyright © 2016 Bluvision. All rights reserved.
//

#import <Foundation/Foundation.h>

@class BLUConfigurableBeacon;
@class BLUBeaconConfiguration;
@class BLUFirmwareImage;

typedef NS_ENUM(NSUInteger, BLUBeaconFirmwareUpdateStage) {
    BLUBeaconFirmwareUpdateStageNone = 0,
    BLUBeaconFirmwareUpdateStageWipe,
    BLUBeaconFirmwareUpdateStageUpdate
};

@interface FirmwareStorage : NSObject

+ (instancetype)defaultStorage;

- (BLUBeaconFirmwareUpdateStage)storedStageForConfigurableBeacon:(BLUConfigurableBeacon *)beacon;
- (BLUFirmwareImage *)storedFirmwareImageForConfigurableBeacon:(BLUConfigurableBeacon *)beacon;

- (void)storeFirmwareUpdateStage:(BLUBeaconFirmwareUpdateStage)stage image:(BLUFirmwareImage *)image forConfigurableBeacon:(BLUConfigurableBeacon *)beacon;
- (void)storeConfiguration:(BLUBeaconConfiguration *)configuration forConfigurableBeacon:(BLUConfigurableBeacon *)beacon;
- (BLUBeaconConfiguration *)storedConfigurationForConfigurableBeacon:(BLUConfigurableBeacon *)beacon;
- (void)removeStoredStageForConfigurableBeacon:(BLUConfigurableBeacon *)beacon;
- (void)removeStoredConfigurationForConfigurableBeacon:(BLUConfigurableBeacon *)beacon;

- (void)clearStoredData;
@end
